
//-------------------------------------------------------------------------------//
// Author: Stefan Lörwald, Universität Heidelberg                                //
// License: CC BY-NC 4.0 http://creativecommons.org/licenses/by-nc/4.0/legalcode //
//-------------------------------------------------------------------------------//

#pragma once

#include <cstddef>

namespace mpi
{
   class Session;

   /// Returns a reference to the MPI session.
   Session& getSession();

   class Session
   {
      public:
         /// Returns true if the node ID is zero.
         bool isMaster() const;
         /// Returns the number of nodes in the setup.
         std::size_t getNumberOfNodes() const;
         friend mpi::Session& mpi::getSession();
      private:
         /// Constructor.
         Session();
         /// Destructor.
         ~Session();
   };
}

